function isEmptyNode(node) {
    if (!(node === null || node === void 0 ? void 0 : node.content) || node.content.length === 0)
        return true;
    return false;
}
export const typstStrings = {
    ',': 'comma',
};
function splitStrings(node) {
    var _a, _b, _c;
    if (((_b = (_a = node.args) === null || _a === void 0 ? void 0 : _a[0].content) === null || _b === void 0 ? void 0 : _b.length) === 1 &&
        ((_c = node.args) === null || _c === void 0 ? void 0 : _c[0].content)[0].type === 'string') {
        node.args[0].content = node.args[0].content[0].content
            .split('')
            .map((l) => ({ type: 'string', content: l }));
    }
}
export const typstMacros = {
    cdot: 'dot.op',
    to: 'arrow.r',
    nonumber: '',
    int: 'integral',
    iint: 'integral.double',
    sqrt: (node) => {
        var _a;
        if (isEmptyNode((_a = node.args) === null || _a === void 0 ? void 0 : _a[0]))
            return 'sqrt';
        return 'root';
    },
    vec: 'arrow',
    mathbf: 'bold',
    boldsymbol: 'bold',
    mathrm: 'upright',
    pm: 'plus.minus',
    partial: 'diff',
    _: (node) => {
        splitStrings(node);
        return '_';
    },
    '^': (node) => {
        splitStrings(node);
        return '^';
    },
    left: (node) => {
        var _a;
        const args = node.args;
        node.args = [];
        const left = ((_a = args === null || args === void 0 ? void 0 : args[0].content) === null || _a === void 0 ? void 0 : _a[0]).content;
        if (left === '(')
            return '(';
        if (left === '[')
            return '[';
        if (left === '{')
            return '{';
        if (left === '|')
            return '|';
        throw new Error(`Undefined left bracket: ${left}`);
    },
    right: (node) => {
        var _a;
        const args = node.args;
        node.args = [];
        const right = ((_a = args === null || args === void 0 ? void 0 : args[0].content) === null || _a === void 0 ? void 0 : _a[0]).content;
        if (right === ')')
            return ')';
        if (right === ']')
            return ']';
        if (right === '}')
            return '}';
        if (right === '|')
            return '|';
        throw new Error(`Undefined right bracket: ${right}`);
    },
    operatorname: (node) => {
        var _a;
        const text = (_a = node.args) === null || _a === void 0 ? void 0 : _a.slice(-1)[0];
        node.args = [{ type: 'macro', content: 'text', args: [text] }];
        return 'op';
    },
    '\\': (node) => {
        node.args = [];
        return '\\\n';
    },
    vdots: 'dots.v',
    ddots: 'dots.down',
};
